import resolve from 'rollup-plugin-node-resolve'
import buble from 'rollup-plugin-buble';
import minify from 'rollup-plugin-minify';
import copy from 'rollup-plugin-copy';
import includePaths from 'rollup-plugin-includepaths';
import license from 'rollup-plugin-license';

export default {
  //dest: 'dist/app.min.js',
  input: 'src/js/index.js',
  output: {
    file: 'dist/js/app.min.js',
    name: 'WBADV',
    format: 'umd',
    sourceMap: true
  },
  plugins: [
    includePaths({
      paths: ['src/js', 'src/js/widget', 'src/js/misc', 'src/js/component', 'src/js/page', 'src/js/dialog']
    }),
    copy({
      'src/html/index.html': 'dist/index.html',
      'src/css/index.css': 'dist/css/index.css',
      'node_modules/bootstrap/dist/css/bootstrap.min.css': 'dist/css/bootstrap.min.css',
      'node_modules/bootstrap/dist/js/bootstrap.min.js': 'dist/js/bootstrap.min.js',
      'node_modules/jquery/dist/jquery.min.js': 'dist/js/jquery.min.js',
      'node_modules/@fortawesome/fontawesome-free/js/fontawesome.min.js': 'dist/js/fontawesome.min.js',
      'node_modules/@fortawesome/fontawesome-free/css/all.min.css': 'dist/css/all.min.css',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-regular-400.eot': 'dist/webfonts/fa-regular-400.eot',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-regular-400.svg': 'dist/webfonts/fa-regular-400.svg',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-regular-400.ttf': 'dist/webfonts/fa-regular-400.ttf',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-regular-400.woff': 'dist/webfonts/fa-regular-400.woff',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-regular-400.woff2': 'dist/webfonts/fa-regular-400.woff2',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-solid-900.eot': 'dist/webfonts/fa-solid-900.eot',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-solid-900.svg': 'dist/webfonts/fa-solid-900.svg',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-solid-900.ttf': 'dist/webfonts/fa-solid-900.ttf',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-solid-900.woff': 'dist/webfonts/fa-solid-900.woff',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-solid-900.woff2': 'dist/webfonts/fa-solid-900.woff2',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-brands-400.eot': 'dist/webfonts/fa-brands-400.eot',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-brands-400.svg': 'dist/webfonts/fa-brands-400.svg',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-brands-400.ttf': 'dist/webfonts/fa-brands-400.ttf',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-brands-400.woff': 'dist/webfonts/fa-brands-400.woff',
      'node_modules/@fortawesome/fontawesome-free/webfonts/fa-brands-400.woff2': 'dist/webfonts/fa-brands-400.woff2',
      'node_modules/js-uuid/js-uuid.js': 'dist/js/js-uuid.js',
      'node_modules/filesize/lib/filesize.js': 'dist/js/filesize.js',
      'node_modules/crypto-js/core.js': 'dist/js/crypto-js/core.js',
      'node_modules/crypto-js/md5.js': 'dist/js/crypto-js/md5.js',
      'src/js/misc/wb-manifest-worker.js': 'dist/js/wb-manifest-worker.js',
      'node_modules/js-yaml/dist/js-yaml.min.js': 'dist/js/js-yaml.min.js',
      verbose: true
    }),
    buble({jsx: 'h'}),
    resolve({}),
    license({
      banner: 'Copyright (C) F. Hoffmann-La Roche AG, 2020.\nAuthor: stanislaw.adaszewski@roche.com\nAll Rights Reserved.',
    }) /* ,
    minify({
      iife: 'dist/app.min.js'
    }) */
  ]
}
