import { h, Component } from 'preact';

class WBBreadcrumbs extends Component {
  render({ items, onItemClicked }) {
    return (
      <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
          { items.map((item, idx) => (
            <li class={ 'breadcrumb-item' +
              (idx == items.length - 1 ? ' active' : '') }>
              {
                (idx < items.length - 1) ? (
                  <a href="#" onclick={ e => { e.preventDefault();
                    onItemClicked(item); } }>{ typeof(item) === 'string' ? item : item['name'] }</a>
                ) : (
                  typeof(item) === 'string' ? item : item['name']
                )
              }
            </li>
          )) }
        </ol>
      </nav>
    );
  }
}

WBBreadcrumbs.defaultProps = {
  'onItemClicked': () => {}
}

export default WBBreadcrumbs;
